#!/usr/bin/python
# -*- coding: utf-8 -*-

from rdtsc import rdtsc 
import time 

def calibr( args = 10 ):
    sum = 0L
    if int( args ) <= 0: n = 10
    else: n = int( args )
    m = n
    while n > 0 :
        cf = -( rdtsc() - rdtsc() )
        sum = sum + cf
        n = n - 1
    return sum / m 

def delay_in_cycle( delay = 1 ):
    t = time.time()
    while time.time() - t < delay :
        time.localtime()

if __name__ == "__main__":
    arg = [ 2, 5, 10, 20, 50, 100 ]
    msg = "калибровка последовательных вызовов:"
    for i in arg:
        s = " %s(%i)" % ( str( calibr( i ) ), i )
        msg = msg + s
    print msg

